#include <alsa/asoundlib.h>
#include <stdlib.h>
#include <alloca.h>

void atest()
{
    char * name = "hw:0,0";
    int result;

    snd_pcm_t *phandle;
    snd_pcm_stream_t stream = SND_PCM_STREAM_PLAYBACK;
    result = snd_pcm_open( &phandle, name, stream, SND_PCM_ASYNC);
    if (result < 0) {
	fprintf(stderr, "error: in snd_pcm_open: %s\n",
		snd_strerror( result ));
	goto out;
    }
    
    snd_pcm_hw_params_t *hw_params;
    snd_pcm_hw_params_alloca( &hw_params );
    result = snd_pcm_hw_params_any( phandle, hw_params );
    if (result < 0) {
	fprintf(stderr, "error: in snd_pcm_hw_params_any: %s\n",
		snd_strerror( result ));
	goto out_close;
    }

    /*
    // extra debug output
    snd_output_t *out;
    snd_output_stdio_attach(&out, stdout, 0);
    snd_pcm_hw_params_dump( hw_params, out );
    */

    unsigned val;
    result = snd_pcm_hw_params_get_channels_max(hw_params, &val);
    printf("max=%u, result=%u\n", val, result);

    result = snd_pcm_hw_params_get_channels_min(hw_params, &val);
    printf("max=%u, result=%u\n", val, result);
    
    out_close:
    snd_pcm_close(phandle );

    out:
    ;
}
